'use strict'
const path = require('path')
const defaultSettings = require('./src/settings.js')
const IncrePack = require('./build/increpack')
const packageJson = require('./package.json')

function resolve(dir) {
  return path.join(__dirname, dir)
}

const name = defaultSettings.title || '管理后台' // page title

// If your port is set to 80,
// use administrator privileges to execute the command line.
// For example, Mac: sudo npm run
// You can change the port by the following methods:
// port = 9528 npm run dev OR npm run dev --port = 9528
const port = process.env.port || process.env.npm_config_port || 9628 // dev port

// All configuration item explanations can be find in https://cli.vuejs.org/config/
module.exports = {
  /**
     * You will need to set publicPath if you plan to deploy your site under a sub path,
     * for example GitHub Pages. If you plan to deploy your site to https://foo.github.io/bar/,
     * then publicPath should be set to '/bar/'.
     * In most cases please use '/' !!!
     * Detail: https://cli.vuejs.org/config/#publicpath
     */
  publicPath: process.env.VUE_APP_PUBLICPATH,
  outputDir: 'dist',
  assetsDir: 'static',
  // lintOnSave: process.env.NODE_ENV === 'development',
  lintOnSave: false,
  productionSourceMap: false,
  devServer: {
    port: port,
    open: false,
    overlay: {
      warnings: false,
      errors: true
    },
    proxy: {
      // change xxx-api/login => mock/login
      // detail: https://cli.vuejs.org/config/#devserver-proxy
      // 如果有多个mock请往里面继续添加
      [process.env.VUE_APP_BASE_API]: {
        timeout: 60000,
        target: process.env.VUE_APP_PROXY_URL,
        // target: `http://127.0.0.1:8090`,
        // target: `http://172.22.80.129`,
        changeOrigin: true
      }
    }
  },
  configureWebpack: {
    // provide the app's title in webpack's name field, so that
    // it can be accessed in index.html to inject the correct title.
    name: name,
    resolve: {
      alias: {
        '@': resolve('src')
      }
    },
    plugins: [
      new IncrePack(packageJson)
    ]
  },
  // 引入rem
  css: {
    loaderOptions: {
      // postcss: {
      //   plugins: [
      //     require('postcss-pxtorem')({ // 把px单位换算成rem单位
      //       rootValue: 16, // 通常结合 lib-flexible 设置 rem 基准值,默认用37.5,不然容易出问题
      //       selectorBlackList: ['.ignore'], // 则是一个对css选择器进行过滤的数组，比如你设置为['fs']，那例如fs-xl类名，里面有关px的样式将不被转换
      //       propList: ['font-size']
      //     })
      //   ]
      // },
      sass: {
        data: `@import './src/assets/css/global.scss';`
      }
    }
  },
  // 兼容浏览器
  transpileDependencies: ['element-ui'],
  chainWebpack(config) {
    config.module
      .rule('babel-geoscene')
      .test(/\.js|\.jsx$/)
      .include
      .add(path.resolve(__dirname, 'node_modules/@geoscene/core'))
      .add(path.resolve(__dirname, 'node_modules/@esri'))
      .add(path.resolve(__dirname, 'node_modules/@zip.js'))
      .end()
      .use('babel-loader')
      .loader('babel-loader')
      .options({
        plugins: [
          ['@babel/plugin-proposal-nullish-coalescing-operator', { loose: true }],
          ['@babel/plugin-proposal-optional-chaining', { loose: true }],
          ['babel-plugin-transform-import-meta']
        ],
        // 确保使用默认 preset-env
        presets: ['@babel/preset-env']
      });

    config.plugins.delete('preload') // TODO: need test
    config.plugins.delete('prefetch') // TODO: need test

    // set svg-sprite-loader
    config.module
      .rule('svg')
      .exclude.add(resolve('src/icons'))
      .end()
    config.module
      .rule('icons')
      .test(/\.svg$/)
      .include.add(resolve('src/icons'))
      .end()
      .use('svg-sprite-loader')
      .loader('svg-sprite-loader')
      .options({
        symbolId: 'icon-[name]'
      })
      .end()

    // set preserveWhitespace
    config.module
      .rule('vue')
      .use('vue-loader')
      .loader('vue-loader')
      .tap(options => {
        options.compilerOptions.preserveWhitespace = true
        return options
      })
      .end()

    config
      // https://webpack.js.org/configuration/devtool/#development
      .when(process.env.NODE_ENV === 'development',
        config => config.devtool('cheap-source-map')
      )

    config
      .when(process.env.NODE_ENV !== 'development',
        config => {
          config
            .plugin('ScriptExtHtmlWebpackPlugin')
            .after('html')
            .use('script-ext-html-webpack-plugin', [{
              // `runtime` must same as runtimeChunk name. default is `runtime`
              inline: /runtime\..*\.js$/
            }])
            .end()
          config
            .optimization.splitChunks({
              chunks: 'all',
              cacheGroups: {
                libs: {
                  name: 'chunk-libs',
                  test: /[\\/]node_modules[\\/]/,
                  priority: 10,
                  chunks: 'initial' // only package third parties that are initially dependent
                },
                elementUI: {
                  name: 'chunk-elementUI', // split elementUI into a single package
                  priority: 20, // the weight needs to be larger than libs and app or it will be packaged into libs or app
                  test: /[\\/]node_modules[\\/]_?element-ui(.*)/ // in order to adapt to cnpm
                },
                commons: {
                  name: 'chunk-commons',
                  test: resolve('src/components'), // can customize your rules
                  minChunks: 3, //  minimum common number
                  priority: 5,
                  reuseExistingChunk: true
                }
              }
            })
          config.optimization.runtimeChunk('single')
        }
      )
  }
}
